%Updated 8-18-2015 by SBS
%Imports and analyzes eye-tracking data

clear all
numsubjects= input('Enter the number of subjects  ','s');
numsubjects=str2num(numsubjects);
startwhere= input('Where do you want to align your data? At the start of ET recording, hit "e", or at the stimulus message, hit "s"  ','s');%This depends on what you consider "trial onset" to be.
%Note in the "demo" program, the audio command (line 313 of the "DEMO_Experiment" script, is closer to the "stimuli" message, so that is the better option for this study.

%data file headers
labels=['T', 'C','O','O','t','c','i','n','s','c','a'];
dlmwrite('demoFixationDurations.txt',labels,'delimiter','\t','-append'); %One file for all subjects--time on each obj
dlmwrite('demoFixationProportions.txt',labels,'delimiter','\t','-append'); %One file for all subjects--prop time on each obj

for immediatesubject=1:numsubjects %runs through the analysis process for each subject.
    
%reads in list of files
listofsubjects = ['subjectlist.txt'];
fid = fopen(listofsubjects);
listofsubjects = textscan(fid,'%s%s%s%s','HeaderLines',1);%column 1 is the subject number, column 2 is the list number, column 3 is the .asc file name
fclose(fid);

immediateascfile = ['datafiles/' listofsubjects{3}{immediatesubject}]; %asc file--eye movement data converted from Eyelink's .edf
immediatetxtfile = ['datafiles/' listofsubjects{4}{immediatesubject}]; %text file--text file with information about (randomized) trial order and which (randomized) port the pictures were in.

eyelink_import_data %import the data

eyelink_analyze_data %analyze the data, write to file

clear data objdata timesummarydata counter timesteps timespent immediateascfile immediatetxtfile

end

eyelink_timecourseAnalysis %generate time-course analyses and a graph for all subjects