% read in eyelink ascii file and convert to something useful...
% SACCADE EVENTS INCLUDED IN DATA STRUCTURE. This can be changed (see below).

fid=fopen(immediateascfile,'rt');

curTrial=0;
startTime=0;
endTime=0;

xoffset=0;
yoffset=0;

compareStart='START';
compareEfix='EFIX';
compareESacc='ESACC';
compareEBlink='EBLINK';
compareMSG='MSG';
compareEND='END'; %new line
record='FALSE'; %defaults to skip position until it finds a message to start recording

    
n=1;
while n<2
    current=fgetl(fid);
    
    if ischar(current)==0
        n=2;
    else
    end;
    
    try       
        
        %%%% CODE TO IMPORT EACH TRIAL STARTING AT THE ET STIMULI MESSAGE
        if startwhere == 's'
            if sum(uint8(compareMSG)==uint8(current(1:3)))==3 %a Message event
                if strfind(current,'Stimuli:') > 1 %a Stimuli event = new trial starting
                    record='TRUE';
                    curTrial=curTrial+1;
                    eventC=0;
                    cText=textscan(current,'%s %d32 %s %s');
                    startTime=cText{2}; %
                else
                end
            end
        elseif startwhere == 'e'
            %%%% CODE TO IMPORT EACH TRIAL STARTING AT THE ET START MESSAGE
            if sum(uint8(compareStart)==uint8(current(1:5)))==5 %new trial starting
                record='TRUE';
                curTrial=curTrial+1;
                eventC=0;
                cText=textscan(current,'%s %d32 %s %s');
                startTime=cText{2};
            else
            end;
        else
        end
        
        if record=='TRUE'; %skips eye data when not in the record position
            if sum(uint8(compareEfix)==uint8(current(1:4)))==4 %an eye fixation event
                eventC=eventC+1;
                cText=textscan(current,'%s %s %d32 %d32 %d32 %d32 %d32 %d32');
                data(eventC,1,curTrial)=1;
                data(eventC,2,curTrial)=cText{3}-startTime;
                data(eventC,3,curTrial)=cText{3}-startTime+cText{5};
                data(eventC,4,curTrial)=cText{6}-xoffset;
                data(eventC,5,curTrial)=cText{7}-yoffset;
            else
            end;

            if sum(uint8(compareEBlink)==uint8(current(1:6)))==6 %blink event
                eventC=eventC+1;
                cText=textscan(current,'%s %s %d32 %d32 %d32');
                data(eventC,1,curTrial)=0; %Changed this from a 2 to a 0 to exclude blinks.
                data(eventC,2,curTrial)=cText{3}-startTime;
                data(eventC,3,curTrial)=cText{3}-startTime+cText{5};
            else
            end;

            %THESE NEXT LINES INCLUDE SACCADE EVENTS IN THE DATA STRUCTURE.
            %if you don't want to include saccades in your fixation durations,
            %comment out these lines.
            if sum(uint8(compareESacc)==uint8(current(1:5)))==5 %saccade event
                eventC=eventC+1;
                cText=textscan(current,'%s %s %d32 %d32 %d32 %d32 %d32 %d32 %d32 %d32 %d32');
                data(eventC,1,curTrial)=3;
                data(eventC,2,curTrial)=cText{3}-startTime; %event onset
                data(eventC,3,curTrial)=cText{3}-startTime+cText{5}; %event offset
                data(eventC,4,curTrial)=cText{8}-xoffset; %saccade landing x
                data(eventC,5,curTrial)=cText{9}-yoffset; %saccade landing y
            else
            end;
        
        else
        end;            
        
        %These lines save a text file with information about your stimuli.
        if sum(uint8(compareMSG)==uint8(current(1:3)))==3 %a Message event
            if strfind(current,'Stimuli:') > 1 %a Stimuli event = new trial starting
                cText=textscan(current,'%s %d32 %s %s');
                dlmwrite('demo_StimuliMessages.txt',current,'delimiter','','-append'); %info about condition for each trial
            else
            end
        end
        
        %new lines:  stop importing at the "END" message.
        if sum(uint8(compareEND)==uint8(current(1:3)))==3 %end of trial
            record='FALSE';
        elseif sum(uint8(compareStart)==uint8(current(1:5)))==5 %stop recording if you encounter the "start" message to next trial (relevant in some cases where the start/stop message gets elimiated due to track problems.
            record='FALSE';
        else
        end;
        
    catch
    end;
end;

dlmwrite('data.txt',data,'\t');

clear c* e* f* n startTime x* y* startTime
clear immediateascfile pathname;
